/*
SRUtil.h

Author: Makoto Kinoshita

Copyright 2004 The Shiira Project. All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted 
provided that the following conditions are met:

  1. Redistributions of source code must retain the above copyright notice, this list of conditions 
  and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright notice, this list of 
  conditions and the following disclaimer in the documentation and/or other materials provided 
  with the distribution.

THIS SOFTWARE IS PROVIDED BY THE SHIIRA PROJECT ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE SHIIRA PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
POSSIBILITY OF SUCH DAMAGE.
*/

#import <Cocoa/Cocoa.h>
#import <WebKit/WebKit.h>
#import "SRError.h"

@class SRBookmark;
@class SRDownloadHistoryItem;

// String
#define UTF8STR(str) \
        [NSString stringWithUTF8String:(str)]
NSString* SRCreateUUID();

// File operations
BOOL SRCreateFile(
        NSString* filePath);
BOOL SRCreateDirectoryFile(
        NSString* filePath, 
        BOOL directory);
NSString* SRCreateUniqueFileName(
        NSString* fileExtension);

// Mouse operations
BOOL SRShowContextMenuByMousePressHolding(
        NSView* view, 
        NSEvent* event);

// View operations
NSView* SRCopyView(
        NSView* view);
id SRViewWithClass(
        NSView* view, 
        Class viewClass);

// Window operations
NSWindow* SRGetFrontMainWindow();

// Bookmark operations
SRBookmark* SRCreateBookmarkFromDownloadHistoryItem(
        SRDownloadHistoryItem* item);

// Sound
NSArray* SoundFilePaths();

// Data handling
NSString* SRCreateDataSizeString(
        long long dataSize);

// Error message
void SRGetErrorMessage(
        NSError* error, 
        WebFrame* frame, 
        NSString** msgText, 
        NSString** infoText, 
        NSString** statusText);
